# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rmp_msgs/RMPCommand.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class RMPCommand(genpy.Message):
  _md5sum = "84cde9e1758addb56d2d271a15c091bc"
  _type = "rmp_msgs/RMPCommand"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# valid command IDs for the Segway
# [RMP_MOTION_CMD_ID, norm_vel_cmd, norm_yaw_cmd]
# [RMP_OMNI_MOTION_CMD_ID, norm_vel_cmd, norm_yaw_cmd, angle_cmd_deg]
# [RMP_CFG_CMD_ID, gp_cmd, gp_param]
uint32 RMP_MOTION_CMD_ID = 1280
uint32 RMP_OMNI_MOTION_CMD_ID = 1536
uint32 RMP_CFG_CMD_ID = 1281

# arg1 some possible values (can also be linear velocity )
uint8 RMP_CMD_SET_OPERATIONAL_MODE = 32
uint8 RMP_CMD_NONE = 0 

# arg2 some possible values (can also be angular velocity)
uint8 DISABLE_REQUEST   = 1
uint8 POWERDOWN_REQUEST = 2
uint8 DTZ_REQUEST       = 3
uint8 STANDBY_REQUEST   = 4
uint8 TRACTOR_REQUEST   = 5
uint8 BALANCE_REQUEST   = 6

# Message content
Header header
uint32 cmd_id
float32 arg1
float32 arg2
float32 arg3

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  # Pseudo-constants
  RMP_MOTION_CMD_ID = 1280
  RMP_OMNI_MOTION_CMD_ID = 1536
  RMP_CFG_CMD_ID = 1281
  RMP_CMD_SET_OPERATIONAL_MODE = 32
  RMP_CMD_NONE = 0
  DISABLE_REQUEST = 1
  POWERDOWN_REQUEST = 2
  DTZ_REQUEST = 3
  STANDBY_REQUEST = 4
  TRACTOR_REQUEST = 5
  BALANCE_REQUEST = 6

  __slots__ = ['header','cmd_id','arg1','arg2','arg3']
  _slot_types = ['std_msgs/Header','uint32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,cmd_id,arg1,arg2,arg3

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RMPCommand, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.cmd_id is None:
        self.cmd_id = 0
      if self.arg1 is None:
        self.arg1 = 0.
      if self.arg2 is None:
        self.arg2 = 0.
      if self.arg3 is None:
        self.arg3 = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.cmd_id = 0
      self.arg1 = 0.
      self.arg2 = 0.
      self.arg3 = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_I3f.pack(_x.cmd_id, _x.arg1, _x.arg2, _x.arg3))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.cmd_id, _x.arg1, _x.arg2, _x.arg3,) = _struct_I3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_I3f.pack(_x.cmd_id, _x.arg1, _x.arg2, _x.arg3))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.cmd_id, _x.arg1, _x.arg2, _x.arg3,) = _struct_I3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_I3f = struct.Struct("<I3f")
